* TEST.PRG : Test the window selection routine

set bell off
set deleted on
set echo off
set exact off
set heading off
set margin to 0
set safety off
set scoreboard off
set talk off
set wrap on

public keypress                   && used to hold key-press values

k_enter   = 13                    && define key values to names
k_return  = 13
k_esc     = 27
k_curs_up = 5
k_curs_dn = 24
k_curs_rt = 4
k_curs_lf = 19
k_ctrl_rt = 2
k_ctrl_lf = 26
k_ins     = 22
k_del     = 7
k_home    = 1
k_end     = 6
k_pgup    = 18
k_pgdn    = 3
k_f2      = -1
k_seek    = -1
k_help    = 28

if iscolor()
  colorn = 'bg/ , /bg,,,+bg/ '
  colorb = '+bg/ ,+gr/ '
  colorh = '+gr/ ,+gr/ '
  colorv = ' /bg,+bg/ ,,,+bg/ '
  colore = '+bg/r,+bg/r'
else
  colorn = 'w/ ,+w/ '
  colorb = '+w/ ,+w/ '
  colorh = '+w/ , /w'
  colorv = ' /w,+w/ ,,,+w/ '
  colore = '* /w,w/ '
endif
color0 = '0/0,0/0'
set color to &colorn

use DTEST
 index on name to TESTN
 index on balance to TESTB
set index to TESTN, TESTB

* array to hold valid exit codes
xix = 3
declare xcode[xix]
xcode[1] = k_del
xcode[2] = k_ins
xcode[3] = k_seek

* array to show info on file
declare fields[lastrec()]

ix = 1
do while ix < 3
  clear
  set order to ix
  iy = 1
  go top
  do while .not. eof()		&& Fill the display array
    fields[iy] = name + '' + str(balance,10,2)
    iy = iy + 1
    skip
  enddo
  titl = 'NAME         BALANCE'
  if ix = 1
    foot = ''
    colr = .T.
    tr = 2			&& screen coordinates
    tc = 41
    br = 19
    sh = .F.			&& shadow = .F.
  else
    foot = ' Sorted by BALANCE'
    colr = .F.
    tr = 5			&& screen coordinates
    tc = 11
    br = 15
    sh = .T.			&& shadow = .T.
  endif
  rec1 = 1			&& starting record
  do while .T.
    indx = lastrec()
    xix = 3
    dchscrn = savescreen(tr,tc,br,79)
    @ 22,33 say '[F2] to Seek'

    do dchoice with tr,tc,br,fields,indx,xcode,xix,sh,colr,titl,foot,rec1
    set color to &colorn
    set order to 1

    do case
    case keypress = k_esc                && ESC to exit loop
      exit
    case keypress = k_return             && Select record
      rec1 = indx                           && set active record pointer
      key = substr(fields[indx],1,10)
      seek key
      do dsmsg with 'Process: ' + name + ' ' + str(balance,10,2)
    case keypress = k_del                && DELETE Job
      key = substr(fields[indx],1,10)
      seek key
      do dsmsg with 'DELETE: ' + name + ' ' + str(balance,10,2)
    case keypress = k_ins                && INSERT new Job
      do dsmsg with 'Insert new record process'
    case keypress = k_seek               && SEEK a Job
      seekscrn = savescreen(10,29,14,52)
      set color to &colorh
      set softseek on
      if ix = 1
        name = space(10)
        @ 10,29 to 14,40 double
        @ 11,30 say 'NAME     '
        @ 12,29 say 'Ķ'
        @ 13,30 get m->name
      else
        balance = 0.00
        @ 10,29 to 14,40 double
        @ 11,30 say '  BALANCE'
        @ 12,29 say 'Ķ'
        @ 13,30 get m->balance picture '9999999.99'
      endif
      read
      if lastkey() = k_esc
        return
      endif
      rec1 = 1                  && FIND the record in the table
      do while rec1 < lastrec() + 1
        if ix = 1
          if m->name <= substr(fields[rec1],1,10)
            exit
          endif
        else
          if str(m->balance,10,2) <= substr(fields[rec1],12,10)
            exit
          endif
        endif
        rec1 = rec1 + 1
      enddo
      if rec1 > lastrec()
        rec1 = lastrec()
      endif
      restscreen(10,29,14,52,seekscrn)
      set softseek off
      set color to &colorv
    otherwise
      loop
    endcase
  enddo
  restscreen(tr,tc,br,79,dchscrn)
  ix = ix + 1
enddo
clear
